var map;
var markers = {};
var polylines = {};
var polygons = {};

//L.mapbox.accessToken = 'MAPBOX_ACCESS_TOKEN';
//map = L.mapbox.map('map', 'mapbox.streets',{ zoomControl : false ,attributionControl : false }).setView([0, 0], 10);
//map = L.mapbox.map('map', 'MAPBOX_MAPID',{ zoomControl : false ,attributionControl : false }).setView([0, 0], 10);
L.mapbox.accessToken = 'pk.eyJ1Ijoiemh1YmFpamlhIiwiYSI6ImNpbzc1ODNubzAyamJ2NmtxMTRxZjZtNW4ifQ.BdzM0DeHWjRKBuYV68WIWQ';
map = L.mapbox.map('map', 'mapbox.streets-basic',{ zoomControl : false ,attributionControl : false }).setView([0, 0], 10);
var myLayer = L.mapbox.featureLayer().addTo(map);
AirMapView.onMapLoaded();


function setBounds(neLat, neLng, swLat, swLng) {
  var southWest = L.latLng(swLat, swLng);
  var northEast = L.latLng(neLat, neLng);
  var bounds = L.latLngBounds(southWest, northEast);
  var bounds2=bounds.pad(0.09);
  map.fitBounds(bounds2);
}

function centerMap(lat, lng) {
  var latLng = L.latLng(lat, lng);
  map.panTo(latLng);
}

function setZoom(zoom) {
  map.setZoom(zoom);
}


function setMapTypeId(mapType) {
  L.mapbox.tileLayer(mapType).addTo(map);
}

function highlightMarker(url ,markerId) {
  var marker = markers[markerId];
  if (marker != null) {
    if (url != "null") {
      marker.setZIndexOffset(20);
      marker.setIcon(L.icon({
        iconUrl: url,
        iconAnchor: [18, 48],
      }));
    }else{
      marker.setIcon(L.mapbox.marker.icon({
          'marker-color': '8a8acb'
      }));
    }
  }
}

function unhighlightMarker(url ,markerId) {
  var marker = markers[markerId];
  if (marker != null) {
    if (url != "null") {
      marker.setZIndexOffset(0);
      marker.setIcon(L.icon({
        iconUrl: url,
        iconAnchor: [15, 40],
      }));
    }else{
      marker.setIcon(L.mapbox.marker.icon({
          'marker-color': 'e55e5e'
      }));
    }
  }
}

function highlightPriceMarker(price,instant,markerId) {
  var marker = markers[markerId];
  if (marker != null) {
    if (price != "null") {
        var innerHtml;
        if(instant){
            innerHtml = '<div class="tooltip white">'+
                   '<span>'+ price +'</span>'+
                   '<span class="flash-icon"></span>'+
                  '</div>';
        }else{
            innerHtml = '<div class="tooltip white">'+
                       '<span>'+ price +'</span>'+
                      '</div>';
        }
    marker.setZIndexOffset(100);
    marker.setIcon(
     L.divIcon({
            "className":'my-div-icon',
            "iconSize":[tooltipWidth,tooltipHeight],
            "html":innerHtml
    })
    );
    var tooltip = $('.tooltip');
    var tooltipWidth = tooltip.width();
    var tooltipHeight = tooltip.height();
    tooltip.css({"left":-tooltipWidth/2 +"px"});
    tooltip.addClass('default');
  }else{
     marker.setIcon(L.mapbox.marker.icon({
          'marker-color': '8a8acb'
      }));
  }
  }
}

function unhighlightPriceMarker(price,instant,markerId) {
  var marker = markers[markerId];
  if (marker != null) {
  if (price != "null") {
      var innerHtml;
      if(instant){
       innerHtml = '<div class="tooltip gray">'+
                   '<span>'+ price +'</span>'+
                   '<span class="flash-icon"></span>'+
                  '</div>';
     }else{
       innerHtml = '<div class="tooltip gray">'+
                       '<span>'+ price +'</span>'+
                      '</div>';
     }

    marker.setZIndexOffset(0);
    marker.setIcon(
     L.divIcon({
            "className":'my-div-icon',
            "iconSize":[tooltipWidth,tooltipHeight],
            "html":innerHtml
    })
    );
    var tooltip = $('.tooltip');
    var tooltipWidth = tooltip.width();
    var tooltipHeight = tooltip.height();
    tooltip.css({"left":-tooltipWidth/2 +"px"});
    tooltip.addClass('default');
  }else{
     marker.setIcon(L.mapbox.marker.icon({
          'marker-color': 'e55e5e'
      }));
  }
  }
}
function addMarker(lat, lng) {
  var marker = L.marker(new L.LatLng(lat, lng), {
      icon: L.mapbox.marker.icon({
          'marker-color': 'e55e5e'
      })
  });
  marker.addTo(map);
  markers.push(marker);
}

function addMarkerWithId(lat, lng, id, title, snippet) {
  addMarkerWithId(lat, lng, id, title, snippet, false);
}

function addMarkerWithId(lat, lng, id, title, snippet, draggable) {
var marker;
if(snippet != "null"){
    marker = L.marker(new L.LatLng(lat, lng), {
      icon: L.icon({
        iconUrl: snippet,
        iconAnchor: [15, 40],
      }),
      draggable: draggable
    });
}else if(title != "null"){
     var innerHtml;
     if(draggable){
    innerHtml = '<div class="tooltip">'+
                   '<span>'+ title +'</span>'+
                   '<span class="flash-icon"></span>'+
                      '</div>';
     }else{
      innerHtml = '<div class="tooltip">'+
                       '<span>'+ title +'</span>'+
                      '</div>';
    }
      var tooltip = $('.tooltip');
      var tooltipWidth = tooltip.width();
      var tooltipHeight = tooltip.height();
      tooltip.css({"left":-tooltipWidth/2 +"px"});
      tooltip.addClass('default');

      marker = L.marker(new L.LatLng(lat, lng), {
          icon: L.divIcon({
                "className":'my-div-icon',
                "iconSize":[tooltipWidth,tooltipHeight],
                "html":innerHtml
        })

      });
  }else{
     marker = L.marker(new L.LatLng(lat, lng), {
          icon: L.mapbox.marker.icon({
              'marker-color': 'e55e5e'
          }),
          draggable: draggable
    });
  }

  marker.addTo(myLayer);
  <!--marker.addTo(map);-->
  <!--map.addLayer(marker);-->

  markers[id] = marker;

  marker.on("click", function(ev) {
    AirMapView.markerClick(id);
  });
  marker.on("dragstart", function(ev) {
    AirMapView.markerDragStart(id, ev.target.getLatLng().lat, ev.target.getLatLng().lng);
  });
  marker.on("drag", function(ev) {
    AirMapView.markerDrag(id, ev.target.getLatLng().lat, ev.target.getLatLng().lng);
  });
  marker.on("dragend", function(ev) {
    AirMapView.markerDragEnd(id, ev.target.getLatLng().lat, ev.target.getLatLng().lng);
  });
}

function moveMarker(lat, long, id) {
  var marker = markers[id];
  if (marker != null) {
    marker.setLatLng( new L.LatLng(lat, long) );
  }
}

function showDefaultInfoWindow(id){
// Not needed
}

function removeMarker(id) {
  var marker = markers[id];
  if (marker != null) {
    map.removeLayer(marker);
  }
}
function clearMarkers() {
  <!--for (lc = 0; lc < markers.length; lc++) {-->
    <!--map.removeLayer(markers[lc]);-->
  <!--}-->
  <!--$('.tooltip').remove();-->
  map.removeLayer(myLayer);
  myLayer = L.mapbox.featureLayer().addTo(map);
  markers = {};
}

function addPolyline(points, id, width, color) {
  color = formatColor(color);
  var polyLine = L.polyline(points, {color: color, weight: width / 2}).addTo(map);

  polylines[id] = polyLine;
}

function removePolyline(id) {
  var polyline = polylines[id];
  if (polyline != null) {
    map.removeLayer(polyline);
  }
}

function removeAllPolylines() {
  for (var key in polylines) {
    removePolyline(key);
  }
  polylines = {};
}

function addPolygon(points, id, width, strokeColor, fillColor) {
  strokeColor = formatColor(strokeColor);
  fillColor = formatColor(fillColor);
  var polygon = L.polygon(points, {color: strokeColor, fillColor: fillColor, weight: width / 2}).addTo(map);

  polygons[id] = polygon;
}

function removePolygon(id) {
  var polygon = polygon[id];
  if (polygon != null) {
    map.removeLayer(polygon);
  }
}

function addCircle(lat, lng, radius, strokeColor, strokeWeight, fillColor) {
  strokeColor = formatColor(strokeColor);
  fillColor = formatColor(fillColor);
  L.circle([lat, lng], radius, {color: strokeColor, weight: strokeWeight, fillColor: fillColor}).addTo(map);
}

function mapClick(event) {
  AirMapView.mapClick(event.latLng.lat(), event.latLng.lng());
}

function mapMove() {
  if (moveTimeout != null) {
    clearTimeout(moveTimeout);
  }
  // javascript bridge not fast enough to handle events immediately.
  moveTimeout = setTimeout(function() {
    var latLng = map.getCenter();
    if (latLng != null) {
      AirMapView.mapMove(latLng.lat(), latLng.lng(), map.getZoom());
    }
  }, 200);
}

function getCenter() {
  var latLng = map.getCenter();
  if (latLng != null) {
    AirMapView.mapCenterCallback(latLng.lat(), latLng.lng());
  }
}

function getBounds() {
  bounds = map.getBounds();
  <!--var bounds2=bounds.pad(-0.09);-->
  <!--ne = bounds2.getNorthEast();-->
  <!--sw = bounds2.getSouthWest();-->

   ne = bounds.getNorthEast();
   sw = bounds.getSouthWest();
   var point1 = map.latLngToLayerPoint(ne);
   var point2 = map.latLngToLayerPoint(sw);

   var nePoint = L.point(point1.x-40,point1.y+50);
   var swPoint = L.point(point2.x+40,point2.y-140);

   var northEast = map.layerPointToLatLng(nePoint);
   var southWest = map.layerPointToLatLng(swPoint);

  AirMapView.getBoundsCallback(northEast.lat, northEast.lng, southWest.lat, southWest.lng);
}

function getScreenLocation(lat, lng) {
    latLng = L.latLng(lat, lng)
    screenLocation = latLngToLayerPoint(latLng);
    AirMapView.getLatLngScreenLocationCallback(screenLocation.x, screenLocation.y)
}

function pointToLatLng(point1X,point1Y,point2X,point2Y){
    var point1 = L.point(point1X,point1Y);
    var point2 = L.point(point2X,point2Y);
    <!--var southWest = L.Projection.Mercator.unproject(point1);-->
    <!--var northEast = L.Projection.Mercator.unproject(point2);-->
     var northEast = map.layerPointToLatLng(point1);
     var southWest = map.layerPointToLatLng(point2);
    AirMapView.getBoundsCallback(northEast.lat, northEast.lng, southWest.lat, southWest.lng);
    <!--AirMapView.getLatLngScreenLocationCallback(screenLocation.x, screenLocation.y)-->
}

// converts an android int color to a web color :)
function formatColor(color) {
  return '#' + ('000000' + (0xFFFFFF & color).toString(16)).slice(-6);
}


